package main

import (
	"fmt"
	"os"

	"github.com/urfave/cli/v2"
)

func main() {
	commands := []*cli.Command{
		gather(),
		plan(),
	}

	app := &cli.App{
		Name:        "forever",
		Usage:       "Create backups designed to last forever",
		Version:     "v1.0.0",
		Description: "ForeverFiles is a system for storing files forever.",
		Commands:    commands,
		Flags:       nil,
		Authors: []*cli.Author{
			{
				Name:  "Mason Payne",
				Email: "mason@masonitestudios.com",
			},
		},
		Copyright:              "2024 Masonite Studios LLC",
		UseShortOptionHandling: true,
	}
	err := app.Run(os.Args)
	if err != nil {
		fmt.Println(fmt.Errorf("error running app | %w", err))
		return
	}
}
